classification
Title: IDLE - add an "Interrupt Execution" to shell menu
Type: enhancement Stage: resolved
Components: IDLE Versions: Python 3.3, Python 3.4, Python 2.7
process
Status: closed Resolution: fixed
Dependencies: Superseder:
Assigned To: Nosy List: Bayard Randel, markroseman, python-dev, roger.serwy, terry.reedy
Priority: low Keywords: easy, patch

Created on 2012-07-09 20:24 by roger.serwy, last changed 2017-06-23 03:40 by terry.reedy. This issue is now closed.

Files
File name Uploaded Description Edit
issue15308.patch roger.serwy, 2012-07-09 20:27 review
interrupt_execution.patch roger.serwy, 2012-07-10 02:59 review
issue15308_updated.patch Bayard Randel, 2016-09-12 02:36 Patch updated for python 3.6.0a4+ review
issue15308_updated-2.patch Bayard Randel, 2016-09-12 02:49 trivial edit review
Messages (8)
msg165122 - (view) Author: Roger Serwy (roger.serwy) * (Python committer) Date: 2012-07-09 20:24
Add an "Interrupt Execution" to the Shell menu, per issue13504, annoyance #3 - "PROBLEM: There’s no obvious way to stop a running program. (Don’t expect them to know Ctrl-C)"
msg165136 - (view) Author: Terry J. Reedy (terry.reedy) * (Python committer) Date: 2012-07-09 23:49
I would like to broaden this to add other missing features to the menus. I have no need for this, but I would like history-next/prev added (to shell, as they only apply there). I never learned them because at first I did not know about them and now it is more bother to select options/configure/keys/scroll-down to find the key binding than to click/return. When I get a new program, I often look through the menus to see what is available, so if things are hidden, how do I find out about them?

Does IDle or tkinter or tk automatically add the key shortcuts?

I notice that some key bindings include lower and upper case, some do not. (History next/prev do not.) Is there a reason to not make all cntl/alt bindings case insensitive, and is there an issue for this?
msg165137 - (view) Author: Terry J. Reedy (terry.reedy) * (Python committer) Date: 2012-07-09 23:52
I was thinking about #12387 about caps lock and shortcuts.
msg165149 - (view) Author: Roger Serwy (roger.serwy) * (Python committer) Date: 2012-07-10 02:50
I'm ok with broadening the scope of this issue to include other items. 
If we decide to deprecate running IDLE without a subprocess 
(http://mail.python.org/pipermail/idle-dev/2012-June/003124.html), then 
the history-next/prev would fit nicely under the Shell menu.
> Does IDle or tkinter or tk automatically add the key shortcuts?
IDLE adds the key shortcuts. It's broken for extensions if those 
shortcuts are changed. See Issue6092.
msg165150 - (view) Author: Roger Serwy (roger.serwy) * (Python committer) Date: 2012-07-10 02:59
The help.txt file needs to be modified as well. See interrupt_execution.patch.
msg275923 - (view) Author: Bayard Randel (Bayard Randel) * Date: 2016-09-12 02:36
I've provided a patch which seems to bring this change up to date on Python 3.6.0a4+, however I've only manually tested. Having had a look at the existing idle tests, it wasn't clear to me how I could also provide a test. Any suggestions would be appreciated. I ran a childrens' coding workshop at Kiwi PyCon 2016 in Dunedin, New Zealand using IDLE and one child in fact raised this issue and was unfamiliar with Ctrl-C.
msg275926 - (view) Author: Bayard Randel (Bayard Randel) * Date: 2016-09-12 02:49
Updated description in idle.rst with a fullstop.
msg275968 - (view) Author: Roundup Robot (python-dev) (Python triager) Date: 2016-09-12 05:57
New changeset 9148a2213631 by Terry Jan Reedy in branch '2.7':
Issue #15308: Add 'interrupt execution' (^C) to Shell menu.
https://hg.python.org/cpython/rev/9148a2213631

New changeset 74b84014bc27 by Terry Jan Reedy in branch '3.5':
Issue #15308: Add 'interrupt execution' (^C) to Shell menu.
https://hg.python.org/cpython/rev/74b84014bc27

New changeset 63f6ac38d18d by Terry Jan Reedy in branch 'default':
Merge 3.5 - Issue #15308: Add 'interrupt execution' (^C) to Shell menu.
https://hg.python.org/cpython/rev/63f6ac38d18d
History
Date User Action Args
2017-06-23 03:40:12terry.reedysetstatus: open -> closed
resolution: fixed
stage: resolved
2016-09-12 05:57:44python-devsetnosy: + python-dev
messages: + msg275968
2016-09-12 02:49:10Bayard Randelsetfiles: + issue15308_updated-2.patch

messages: + msg275926
2016-09-12 02:36:53Bayard Randelsetfiles: + issue15308_updated.patch
nosy: + Bayard Randel
messages: + msg275923

2015-09-18 16:32:21markrosemansetnosy: + markroseman
2013-06-15 19:03:50terry.reedysetversions: + Python 3.4
2012-07-10 02:59:26roger.serwysetfiles: + interrupt_execution.patch

messages: + msg165150
2012-07-10 02:50:28roger.serwysetmessages: + msg165149
2012-07-09 23:52:55terry.reedysetmessages: + msg165137
2012-07-09 23:49:42terry.reedysetmessages: + msg165136
2012-07-09 20:27:59roger.serwylinkissue13504 dependencies
2012-07-09 20:27:29roger.serwysetfiles: + issue15308.patch
keywords: + patch
2012-07-09 20:24:50roger.serwycreate